package core.streams;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;

import core.structures.Config;

/**
 * 
 * <pre>
 *  Copyright (c) 2006 Dominik Schulz
 *  Copyright (c) 2006 Florian Lindner
 *  Copyright (c) 2006 Philip Hartmann
 *  
 *  This file is part of jPOPc.
 *
 *  jPOPc is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  jPOPc is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with jPOPc; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  </pre>
 *  
 * This class is currently not in use.
 * 
 * @author Florian
 * @author Dominik
 * 
 */
@Deprecated
public class MailReader extends BufferedReader {

	public MailReader(Reader r, int mode) {
		super(r);
		this.mode = mode;
	}

	private boolean			headerRead	= false;

	private int				mode		= 0;		// do we read header (0) or body (1)?

	public final static int	HEADER		= 0;

	public final static int	BODY		= 1;

	public String readLine() throws IOException {
		// read header and read allready
		if (this.mode == MailReader.HEADER && this.headerRead) {
			return null;
			// read header and not read allready
		} else if (this.mode == MailReader.HEADER && !this.headerRead) {
			int buffer = -1;
			String currentLine = "";
			while ((buffer = super.read()) != -1) {
				if (buffer != "\r".toCharArray()[0]) {
					currentLine += (char) buffer;
				} else {
					if (super.read() == "\n".toCharArray()[0]) {
						if (currentLine.equals(Config.CRLF) || currentLine.length() < 1) {
							this.headerRead = true;
						}
						return currentLine;
					} else {
						currentLine += "\n";
					}
				}
			}
			if (currentLine.length() < 1) {
				return null;
			} else {
				return currentLine;
			}
			// read body and header read allready
		} else if (this.mode == MailReader.BODY && this.headerRead) {
			return super.readLine();
			// read body and header not read allready
		} else if (this.mode == MailReader.BODY && !this.headerRead) {
			while (!this.headerRead) {
				int buffer = 0;
				String currentLine = "";
				while ((buffer = super.read()) != -1) {
					if (buffer != "\r".toCharArray()[0]) {
						currentLine += (char) buffer;
					} else {
						if (super.read() == "\n".toCharArray()[0]) {
							if (currentLine.equals(Config.CRLF) || currentLine.length() < 1) {
								this.headerRead = true;
							}
							// return currentLine;
							break;
						} else {
							currentLine += "\n";
						}
					}
				}
			}
			return super.readLine();
		} else {
			return null;
		}
	}

	public static void main(String[] args) throws IOException {
		File mail = new File(Config.CACHE_BASE_FILENAME + 1 + Config.CACHE_EXTENSION);
		FileReader fr = new FileReader(mail);
		MailReader mr = new MailReader(fr, MailReader.BODY);
		String buffer = "";
		while ((buffer = mr.readLine()) != null) {
			System.out.println(buffer);
		}
	}

}
