package core.threads;

import org.apache.log4j.Logger;

import core.Pop3Connection;
import core.structures.Mailbox;

/**
 * 
 * <pre>
 *  Copyright (c) 2006 Dominik Schulz
 *  Copyright (c) 2006 Florian Lindner
 *  Copyright (c) 2006 Philip Hartmann
 *  
 *  This file is part of jPOPc.
 *
 *  jPOPc is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  jPOPc is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with jPOPc; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  </pre>
 *  
 * This class is only responsible for parsing a single mail from our temp-dir.
 * 
 * @author tex
 * 
 */
public class ParseMailThread implements Runnable {

	static Logger	logger	= Logger.getLogger(ParseMailThread.class);

	private Mailbox	mbx		= null;

	private int		offset	= 0;

	public ParseMailThread(Mailbox mbox, int offset) {
		this.mbx = mbox;
		this.offset = offset;
	}

	public void run() {
		this.mbx.addMessage(Pop3Connection.getMailFile(this.offset));
	}

}
