package core.util;

import java.util.Vector;

import org.apache.log4j.Logger;

@Deprecated
public class Base64 {

	static Logger			logger		= Logger.getLogger(Base64.class);

	/**
	 * The Base 64 charset as defined in the RFC
	 */
	public static char[]	ALPHABET	= { (byte) 'A', (byte) 'B', (byte) 'C', (byte) 'D', (byte) 'E', (byte) 'F',
			(byte) 'G', (byte) 'H', (byte) 'I', (byte) 'J', (byte) 'K', (byte) 'L', (byte) 'M', (byte) 'N', (byte) 'O',
			(byte) 'P', (byte) 'Q', (byte) 'R', (byte) 'S', (byte) 'T', (byte) 'U', (byte) 'V', (byte) 'W', (byte) 'X',
			(byte) 'Y', (byte) 'Z', (byte) 'a', (byte) 'b', (byte) 'c', (byte) 'd', (byte) 'e', (byte) 'f', (byte) 'g',
			(byte) 'h', (byte) 'i', (byte) 'j', (byte) 'k', (byte) 'l', (byte) 'm', (byte) 'n', (byte) 'o', (byte) 'p',
			(byte) 'q', (byte) 'r', (byte) 's', (byte) 't', (byte) 'u', (byte) 'v', (byte) 'w', (byte) 'x', (byte) 'y',
			(byte) 'z', (byte) '0', (byte) '1', (byte) '2', (byte) '3', (byte) '4', (byte) '5', (byte) '6', (byte) '7',
			(byte) '8', (byte) '9', (byte) '+', (byte) '/' };

	public char[]			DECABETH	= null;

	public static String removeLinefeed(String msg) {
		return msg.replace("\n", "").replace("\r", "").replace("=", "");
	}

	/**
	 * generates the ASCI alphabeth
	 * 
	 */
	public void genDecAbeth() {
		this.DECABETH = new char[ALPHABET.length];
		for (int i = 0; i < ALPHABET.length; i++) {
			this.DECABETH[(int) ALPHABET[i]] = (char) i;
			logger.info(i + " = " + this.DECABETH[i]);
		}
	}

	/**
	 * returns the 64-bases value of an ascii-char
	 */
	public static int get64Value(char ch) {
		for (int i = 0; i < ALPHABET.length; i++) {
			if ((int) ((char) ALPHABET[i]) == (int) ch) {
				return i;

			}
		}
		return 0;
	}

	@SuppressWarnings("unchecked")
	public static String decode(String msg) {
		msg = removeLinefeed(msg);
		// fill bit-Vector
		Vector bits = new Vector(msg.length() * 6);
		SixBit sb;
		for (int i = 0; i < msg.length(); i++) {
			sb = new SixBit(msg.charAt(i));
			for (int j = 0; j < 6; j++) {
				bits.add(sb.getBitArray()[j]);
			}
		}

		// transform into 8-bit-ascii
		String result = "";
		boolean nextIsUmlaut = false;
		int tmp;
		int count = 0;
		// translate into binary
		for (int k = 0; k < bits.size() / 8; k++) {
			tmp = 0;
			if (bits.elementAt(count + 0) == Boolean.TRUE)
				tmp += 128;
			if (bits.elementAt(count + 1) == Boolean.TRUE)
				tmp += 64;
			if (bits.elementAt(count + 2) == Boolean.TRUE)
				tmp += 32;
			if (bits.elementAt(count + 3) == Boolean.TRUE)
				tmp += 16;
			if (bits.elementAt(count + 4) == Boolean.TRUE)
				tmp += 8;
			if (bits.elementAt(count + 5) == Boolean.TRUE)
				tmp += 4;
			if (bits.elementAt(count + 6) == Boolean.TRUE)
				tmp += 2;
			if (bits.elementAt(count + 7) == Boolean.TRUE)
				tmp += 1;
			count += 8;
			// Remove asci->0 from the text, care about umlaute
			if (nextIsUmlaut) {
				nextIsUmlaut = false;
				switch (tmp) {
				case 164: // ae
					// result += '�';
					break;
				case 188: // ue
					// result += '�';
					break;
				case 159: // ss
					// result += '�';
					break;
				case 182: // oe
					// result += '�';
					break;
				default:
					logger.error("Special character could not be identified! ASCII: " + tmp);
					// adding the char as found in the ascitable for unknown chars
					result += (char) tmp;
				}
			} else { // remove NULL-chars
				if (tmp == 0)
					tmp = 32;
				if (tmp == 195)
					nextIsUmlaut = true;
				else
					result += (char) tmp;
			}
		}
		return result;
	}

	public static void main(String[] args) {
		System.out
				.println(decode("SMOkdHRlbiBIw7x0ZSBlaW4gw58gaW0gTmFtZW4sIHfDpHJlbiBzaWUgbcO2Z2xpY2hlcndlaXNlIGtlaW5lIEjDvHRlIG1laHIsDQpzb25kZXJuIEjDvMOfZS4NCg=="));
	}

}
