package gui;

import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;

/**
 * 
 * <pre>
 *  Copyright (c) 2006 Dominik Schulz
 *  Copyright (c) 2006 Florian Lindner
 *  Copyright (c) 2006 Philip Hartmann
 *  
 *  This file is part of jPOPc.
 *
 *  jPOPc is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  jPOPc is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with jPOPc; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  </pre>
 *  
 * @author Dominik
 *
 */
public class JButtonWithInfo extends JButton {

	private static final long	serialVersionUID	= -1786956818911767694L;

	private int					infoId				= 0;

	private String				infoText			= "";

	public JButtonWithInfo() {
	}

	public JButtonWithInfo(Icon icon) {
		super(icon);
	}

	public JButtonWithInfo(String text) {
		super(text);
	}

	public JButtonWithInfo(Action a) {
		super(a);
	}

	public JButtonWithInfo(String text, Icon icon) {
		super(text, icon);
	}

	/**
	 * @return the infoId
	 */
	public int getInfoId() {
		return infoId;
	}

	/**
	 * @param infoId
	 *            the infoId to set
	 */
	public void setInfoId(int infoId) {
		this.infoId = infoId;
	}

	/**
	 * @return the infoText
	 */
	public String getInfoText() {
		return infoText;
	}

	/**
	 * @param infoText
	 *            the infoText to set
	 */
	public void setInfoText(String infoText) {
		this.infoText = infoText;
	}

}
